//ULTRAZVUK DÁLKA



#include <Wire.h>
#include <EEPROM.h>
#include <Adafruit_GFX.h>
#include <Adafruit_SSD1306.h>
#define SCREEN_WIDTH 128 // OLED display width, in pixels
#define SCREEN_HEIGHT 64 // OLED display height, in pixels
Adafruit_SSD1306 display(SCREEN_WIDTH, SCREEN_HEIGHT, &Wire, -1);

int M =1;// TL MENY
int S =1;// TL S TART
int n =1;// citac meny

int LMAX=60;// M10
int LMIN =20;// M20

#define trigPin 9      // Trigger Pin
#define echoPin 10      // Echo Pin


int maximumRange = 200;       // maximální vzdálenost
int minimumRange = 0;       // minimální vzdálenost
float duration = 0;         // delka pulsu
int distance = 0;         // vzdalenost cela cisla
float CV = 0.34;         // KONSTANTA SIRENI X 10
//===================================================================
 void setup() {
//EEPROM.write(10, 0); 
//n = EEPROM.read(10);
Serial.begin(115200);

 if(!display.begin(SSD1306_SWITCHCAPVCC, 0x3C)) {
 Serial.println(F("SSD1306 allocation failed")); }

  Serial.begin (9600);
  pinMode(trigPin, OUTPUT);
  pinMode(echoPin, INPUT);
  
  //A2 INPUT MENY/START
  //A0 INPUT_PARAMETR

 display.clearDisplay(); display.setTextSize(2);display.setTextColor(WHITE);
 display.setCursor(0,0); display.print("DALKOMER");
 display.setCursor(0,20);display.print("READY");
 display.display();
 delay(1500);

 }
//===================================================================== 
void loop() {
 M = analogRead(A2); S = analogRead(A0);Serial.println(M);Serial.println(S);
if (M <= 70){n=n+1;};  
if (n >= 11){n=1;};
if (n == 1){fce1();} // DALKOMER
if (n == 2){fce2();} // KOMPARACE 1
//======================KOMPARACE 2============================================
if (n == 3){
  digitalWrite(trigPin, LOW);
  delayMicroseconds(2);
  digitalWrite(trigPin, HIGH);
  delayMicroseconds(10);
  digitalWrite(trigPin, LOW);
  duration = pulseIn(echoPin, HIGH);
  distance = (duration*CV )/ 20;   //vypočítání v cm

display.clearDisplay(); display.setTextSize(2);display.setTextColor(WHITE);
display.setCursor(0,0); display.print("L >= ");display.print(LMIN);

if (distance <= LMAX){display.setCursor(10,40);display.print("NE");
display.display();  delay(500);} 

if (distance > LMAX){display.setCursor(10,40);display.print("ANO");
display.display();  delay(500);}
} 

//=============================ZADANI LMAX========================================
if (n == 4){
  if (S <= 70){LMAX=LMAX+1;}; 
  if (LMAX > 200){LMAX=20;}; 
display.clearDisplay(); display.setTextSize(2);display.setTextColor(WHITE);
display.setCursor(0,0); display.print("ZADEJ Lmax");
display.setCursor(0,40);display.print(LMAX);
display.display();   delay(500);};
//==============================ZADANI LMIN=======================================
if (n == 5){
   if (S <= 70){LMIN=LMIN-1;}; 
  if (LMIN < 5){LMIN=50;}; 
display.clearDisplay(); display.setTextSize(2);display.setTextColor(WHITE);
display.setCursor(0,0); display.print("ZADEJ Lmin");
display.setCursor(0,40);display.print(LMIN);
display.display();   delay(500);};

//===============================KALIBRACE + =======================================
if (n == 6){
   if (S <= 70){CV=CV+0.01;}; 
  if (CV > 0.41){CV=0.30;}; 
display.clearDisplay(); display.setTextSize(2);display.setTextColor(WHITE);
display.setCursor(0,0); display.print("KALIBRACE+");
display.setCursor(0,40);display.print("CV= ");display.print(CV);
display.display();   delay(500);};
//===============================KALIBRACE - =======================================
if (n == 7){
   if (S <= 70){CV=CV-0.01;}; 
  if (CV < 0.30){CV=0.04;}; 
display.clearDisplay(); display.setTextSize(2);display.setTextColor(WHITE);
display.setCursor(0,0); display.print("KALIBRACE-");
display.setCursor(0,40);display.print("CV= ");display.print(CV);
display.display();   delay(500);};

//==============================NASTAV Lmax=======================================
if (n == 8){
   if (S <= 70){LMAX=LMAX+1;}; 
  if (LMAX > 201){LMAX=10;}; 
display.clearDisplay(); display.setTextSize(2);display.setTextColor(WHITE);
display.setCursor(0,0); display.print("SET Lmax");
display.setCursor(0,40);display.print("Lmax = ");display.print(LMAX);
display.display();   delay(500);};

//==============================NASTAV Lmin=======================================
if (n == 9){
   if (S <= 70){LMIN=LMIN+1;}; 
  if (LMIN > 201){LMIN=10;}; 
display.clearDisplay(); display.setTextSize(2);display.setTextColor(WHITE);
display.setCursor(0,0); display.print("SET Lmin");
display.setCursor(0,40);display.print("Lmin = ");display.print(LMIN);
display.display();   delay(500);};




//======================================================================
  delay(1000);
}
 

//===================================podprogramy ============
void fce1() {
  digitalWrite(trigPin, LOW);
  delayMicroseconds(2);
  digitalWrite(trigPin, HIGH);
  delayMicroseconds(10);
  digitalWrite(trigPin, LOW);
  duration = pulseIn(echoPin, HIGH);
  distance = (duration*0.34 )/ 20;   //vypočítání v cm
  
 display.clearDisplay(); display.setTextSize(2);display.setTextColor(WHITE);
 display.setCursor(0,0); display.print("DALKOMER");
 display.setCursor(0,20);display.print("L(cm)=");
 display.setCursor(10,40);display.print(distance);
 display.display(); delay(500);
 return;}
//=========================================KOMPARACE DELKY MAX=============================
void fce2() {
  digitalWrite(trigPin, LOW);
  delayMicroseconds(2);
  digitalWrite(trigPin, HIGH);
  delayMicroseconds(10);
  digitalWrite(trigPin, LOW);
  duration = pulseIn(echoPin, HIGH);
  distance = (duration*CV )/ 20;   //vypočítání v cm

display.clearDisplay(); display.setTextSize(2);display.setTextColor(WHITE);
display.setCursor(0,0); display.print("L <= ");display.print(LMAX);

if (distance <= LMAX){display.setCursor(10,40);display.print("ANO");
display.display();  delay(500);} 

if (distance > LMAX){display.setCursor(10,40);display.print("NE");
display.display();  delay(500);}

return;}

//=========================================================================================




